
void _efl_ui_focus_manager_root_focus_canvas_object_set(Eo *obj, Efl_Ui_Focus_Manager_Root_Focus_Data *pd, Efl_Canvas_Object *canvas_object);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_focus_manager_root_focus_canvas_object_set, EFL_FUNC_CALL(canvas_object), Efl_Canvas_Object *canvas_object);

Efl_Canvas_Object *_efl_ui_focus_manager_root_focus_canvas_object_get(const Eo *obj, Efl_Ui_Focus_Manager_Root_Focus_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_focus_manager_root_focus_canvas_object_get, Efl_Canvas_Object *, NULL);

Eina_Bool _efl_ui_focus_manager_root_focus_efl_ui_focus_manager_calc_register_logical(Eo *obj, Efl_Ui_Focus_Manager_Root_Focus_Data *pd, Efl_Ui_Focus_Object *child, Efl_Ui_Focus_Object *parent, Efl_Ui_Focus_Manager *redirect);


Eina_Bool _efl_ui_focus_manager_root_focus_efl_ui_focus_manager_calc_register(Eo *obj, Efl_Ui_Focus_Manager_Root_Focus_Data *pd, Efl_Ui_Focus_Object *child, Efl_Ui_Focus_Object *parent, Efl_Ui_Focus_Manager *redirect);


void _efl_ui_focus_manager_root_focus_efl_ui_focus_manager_calc_unregister(Eo *obj, Efl_Ui_Focus_Manager_Root_Focus_Data *pd, Efl_Ui_Focus_Object *child);


void _efl_ui_focus_manager_root_focus_efl_ui_focus_manager_manager_focus_set(Eo *obj, Efl_Ui_Focus_Manager_Root_Focus_Data *pd, Efl_Ui_Focus_Object *focus);


Efl_Ui_Focus_Object *_efl_ui_focus_manager_root_focus_efl_ui_focus_manager_manager_focus_get(const Eo *obj, Efl_Ui_Focus_Manager_Root_Focus_Data *pd);


Efl_Ui_Focus_Relations *_efl_ui_focus_manager_root_focus_efl_ui_focus_manager_fetch(Eo *obj, Efl_Ui_Focus_Manager_Root_Focus_Data *pd, Efl_Ui_Focus_Object *child);


Efl_Ui_Focus_Manager_Logical_End_Detail _efl_ui_focus_manager_root_focus_efl_ui_focus_manager_logical_end(Eo *obj, Efl_Ui_Focus_Manager_Root_Focus_Data *pd);


Eina_Iterator *_efl_ui_focus_manager_root_focus_efl_ui_focus_manager_border_elements_get(const Eo *obj, Efl_Ui_Focus_Manager_Root_Focus_Data *pd);


Eina_Iterator *_efl_ui_focus_manager_root_focus_efl_ui_focus_manager_viewport_elements_get(const Eo *obj, Efl_Ui_Focus_Manager_Root_Focus_Data *pd, Eina_Rect viewport);


Efl_Ui_Focus_Object *_efl_ui_focus_manager_root_focus_efl_ui_focus_manager_request_move(Eo *obj, Efl_Ui_Focus_Manager_Root_Focus_Data *pd, Efl_Ui_Focus_Direction direction, Efl_Ui_Focus_Object *child, Eina_Bool logical);


Efl_Ui_Focus_Object *_efl_ui_focus_manager_root_focus_efl_ui_focus_manager_move(Eo *obj, Efl_Ui_Focus_Manager_Root_Focus_Data *pd, Efl_Ui_Focus_Direction direction);


Efl_Object *_efl_ui_focus_manager_root_focus_efl_object_constructor(Eo *obj, Efl_Ui_Focus_Manager_Root_Focus_Data *pd);


void _efl_ui_focus_manager_root_focus_efl_object_destructor(Eo *obj, Efl_Ui_Focus_Manager_Root_Focus_Data *pd);


Efl_Object *_efl_ui_focus_manager_root_focus_efl_object_finalize(Eo *obj, Efl_Ui_Focus_Manager_Root_Focus_Data *pd);


static Eina_Bool
_efl_ui_focus_manager_root_focus_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_FOCUS_MANAGER_ROOT_FOCUS_EXTRA_OPS
#define EFL_UI_FOCUS_MANAGER_ROOT_FOCUS_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_root_focus_canvas_object_set, _efl_ui_focus_manager_root_focus_canvas_object_set),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_root_focus_canvas_object_get, _efl_ui_focus_manager_root_focus_canvas_object_get),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_calc_register_logical, _efl_ui_focus_manager_root_focus_efl_ui_focus_manager_calc_register_logical),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_calc_register, _efl_ui_focus_manager_root_focus_efl_ui_focus_manager_calc_register),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_calc_unregister, _efl_ui_focus_manager_root_focus_efl_ui_focus_manager_calc_unregister),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_focus_set, _efl_ui_focus_manager_root_focus_efl_ui_focus_manager_manager_focus_set),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_focus_get, _efl_ui_focus_manager_root_focus_efl_ui_focus_manager_manager_focus_get),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_fetch, _efl_ui_focus_manager_root_focus_efl_ui_focus_manager_fetch),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_logical_end, _efl_ui_focus_manager_root_focus_efl_ui_focus_manager_logical_end),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_border_elements_get, _efl_ui_focus_manager_root_focus_efl_ui_focus_manager_border_elements_get),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_viewport_elements_get, _efl_ui_focus_manager_root_focus_efl_ui_focus_manager_viewport_elements_get),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_request_move, _efl_ui_focus_manager_root_focus_efl_ui_focus_manager_request_move),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_move, _efl_ui_focus_manager_root_focus_efl_ui_focus_manager_move),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_ui_focus_manager_root_focus_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_destructor, _efl_ui_focus_manager_root_focus_efl_object_destructor),
      EFL_OBJECT_OP_FUNC(efl_finalize, _efl_ui_focus_manager_root_focus_efl_object_finalize),
      EFL_UI_FOCUS_MANAGER_ROOT_FOCUS_EXTRA_OPS
   );
   opsp = &ops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_focus_manager_root_focus_class_desc = {
   EO_VERSION,
   "Efl.Ui.Focus.Manager_Root_Focus",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Ui_Focus_Manager_Root_Focus_Data),
   _efl_ui_focus_manager_root_focus_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_focus_manager_root_focus_class_get, &_efl_ui_focus_manager_root_focus_class_desc, EFL_UI_FOCUS_MANAGER_CALC_CLASS, NULL);
